动态规划
poj 3666 Making the Grade (动态规划)
Making the Grade
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 4647 | Accepted: 2202 |
Description
A straight dirt road connects two fields on FJ's farm, but it changes elevation more than FJ would like. His cows do not mind climbing up or down a single slope, but they are not fond of an alternating succession of hills and valleys. FJ would like to add and remove dirt from the road so that it becomes one monotonic slope (either sloping up or down).
You are given N integers A_{1}, ... , A_{N} (1 ≤ N ≤ 2,000) describing the elevation (0 ≤ A_{i} ≤ 1,000,000,000) at each of N equally-spaced positions along the road, starting at the first field and ending at the other. FJ would like to adjust these elevations to a new sequence B_{1}, . ... , B_{N} that is either nonincreasing or nondecreasing. Since it costs the same amount of money to add or remove dirt at any position along the road, the total cost of modifying the road is
|A_{1}六合联盟， - B_{1}| |A_{2} - B_{2}| ... |A_{N} - B_{N} |
Please compute the minimum cost of grading his road so it becomes a continuous slope. FJ happily informs you that signed 32-bit integers can certainly be used to compute the answer.
Input
* Line 1: A single integer: N
* Lines 2..N 1: Line i 1 contains a single integer elevation:
A_{i}
Output
* Line 1: A single integer that is the minimum cost for FJ to grade his dirt road so it becomes nonincreasing or nondecreasing in elevation.
Sample Input
7
1
3
2
4
5
3
9
Sample Output
3
一个想法是：对于a[i],枚举任一高度作为最大高度，取前i-1个的合法最优解。
数据范围很大10^9，但n只有2000大小，可以离散化，用坐标代替高度。
a[i]存原始数组，b[j]存排序后递增的数组。
dp[i][j]=min(dp[i-1][0..j]) abs(a[i]-b[j]); （把第i 个数高度改为b[j],此时的最小成本。）
#include
#include
#include
#include
#include
#include
#include
using namespace std;
#define ll __int64
#define mem(a,t) memset(a,t,sizeof(a))
#define N 2005
const int M=305;
const int inf=0x7fffffff;
int a[N],b[N];
int dp[N];
void solve(int n)
{
int i,j,tmp;
sort(b,b n);
for(i=0;i
3666 Making the Grade (动态规划) Making the Grade Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 4647 Accepted: 2202 Description A straight dirt road connects t...
Making the Grade
Description
A straight dirt road connects two fields on FJ's farm, but it changes elevation more than FJ would like. His cows do not mind climbing up or down a single slope, but they are not fond of an alternating succession of hills and valleys. FJ would like to add and remove dirt from the road so that it becomes one monotonic slope (either sloping up or down).
Making the Grade
You are given N integers A1, ... , AN (1 ≤ N ≤ 2,000) describing the elevation (0 ≤ Ai ≤ 1,000,000,000) at each of N equally-spaced positions along the road, starting at the first field and ending at the other. FJ would like to adjust these elevations to a new sequence B1, . ... , BN that is either nonincreasing or nondecreasing. Since it costs the same amount of money to add or remove dirt at any position along the road, the total cost of modifying the road is
Time Limit: 1000MS | Memory Limit: 65536K | |
Total Submissions: 5797 | Accepted: 2714 |
|A1 - B1| |A2 - B2| ... |AN - BN |
Please compute the minimum cost of grading his road so it becomes a
continuous slope. FJ happily informs you that signed 32-bit integers can
certainly be used to compute the answer.
Description
Input
A straight dirt road connects two fields on FJ's farm, but it changes elevation more than FJ would like. His cows do not mind climbing up or down a single slope, but they are not fond of an alternating succession of hills and valleys. FJ would like to add and remove dirt from the road so that it becomes one monotonic slope (either sloping up or down).
- Line 1: A single integer: N
- Lines 2..N 1: Line i 1 contains a single integer elevation: Ai
You are given N integers A_{1}, ... , A_{N} (1 ≤ N ≤ 2,000) describing the elevation (0 ≤ A_{i} ≤ 1,000,000,000) at each of N equally-spaced positions along the road, starting at the first field and ending at the other. FJ would like to adjust these elevations to a new sequence B_{1}, . ... , B_{N} that is either nonincreasing or nondecreasing. Since it costs the same amount of money to add or remove dirt at any position along the road, the total cost of modifying the road is
Output
|A_{1} - B_{1}| |A_{2} - B_{2}| ... |A_{N} - B_{N} |
- Line 1: A single integer that is the minimum cost for FJ to grade his dirt road so it becomes nonincreasing or nondecreasing in elevation.
Please compute the minimum cost of grading his road so it becomes a continuous slope. FJ happily informs you that signed 32-bit integers can certainly be used to compute the answer.
Sample Input
Input
7
1
3
2
4
5
3
9
Sample Output
* Line 1: A single integer: N
* Lines 2..N 1: Line i 1 contains a single integer elevation:
A_{i}
3
Output
* Line 1: A single integer that is the minimum cost for FJ to grade his dirt road so it becomes nonincreasing or nondecreasing in elevation.
Sample Input
7
1
3
2
4
5
3
9
Sample Output
3
Source
USACO 2008 February Gold
/*
解题思路整理--题意：花费最少代价使序列单调不下降或不上升
f[i,j]表示第i段路升高到是s[j]，abs(h[i]-s[j])为原高度与ans对应高度的差
于是f[i,j]=min(f[i-1,k] abs(h[i]-s[j]))（k<=j)
o(n3)要tle的节奏。
那么预处理--f[i-1,k]：
开一个数组g[i,j]表示前i段路中升高到s[j]的最小花费,
g[i,j]=min(g[i,j-1],f[i,j])。
最终：f[i,j]=g[i-1,j] abs[a[i]-c[j]]; o(n2)
具体实现--sort s 正排一遍，倒排一遍 dp2遍--AC
*/
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#define N 2010
using namespace std;
int s[N],h[N],n,res=2137483648;
int f[N][N],g[N][N];
int cmp(int a,int b){
return a>b;
}
void dp(){
for(int i=1;i<=n;i ){
for(int j=1;j<=n;j ){
f[i][j]=g[i-1][j] abs(h[i]-s[j]);
if(j==1) g[i][j]=f[i][j];
else g[i][j]=min(g[i][j-1],f[i][j]);
}
}
for(int i=1;i<=n;i ){
res=min(res,f[n][i]);
}
}
int main(){
scanf("%d",&n);
for(int i=1;i<=n;i ){
scanf("%d",h i);s[i]=h[i];
}
sort(s 1,s n 1);dp();
sort(s 1,s n 1,cmp);dp();
printf("%dn",res);
return 0;
}
版权声明：本文由六合联盟发布于编程,转载请注明出处：动态规划